package ontologyview.utils;

import java.util.ArrayList;
import java.util.List;

public class FMAGraph {

	private SuperCompressedFMA fma;

	public FMAGraph(String s) {
		fma = SuperCompressedFMA.loadFromFile(s);
		if (fma == null) throw new RuntimeException("couldn't load FMA at "+s);
	}

	public String getInversePredicate(String predicate) {
		String s = fma.invSlotMap.get(predicate);
		if (s==null) throw new IllegalArgumentException("inverse predicate "+predicate+" not available");
		return s;
	}

	public List<String> getObjects(String subject, String predicate) {
		Integer is,ip;
		if ((is=fma.find(subject))==null) throw new IllegalArgumentException("subject "+subject+" not in graph");
		if ((ip=fma.strToInt.get(predicate))==null) throw new IllegalArgumentException("predicate "+predicate+" not available");
		int[] foo = fma.getConnectivity(is,ip);
		List<String> al = new ArrayList<String>();
		if (foo!=null) {
			for(int i=0; i<foo.length; i++) {
				int j=fma.find(foo[i]);
				if (j==-1) continue;
				String s=fma.getName(j);
				if (predicate.equals(":DIRECT-SUPERCLASSES") && s.contains("template")) continue;
				al.add(s);
			}
		}
		return al;
	}

}